#include <signal.h>
#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

static bool done = false;

void handler(int signo) {
    if (signo == SIGALRM) {
        while (!done) {
            printf("I'm loooooping.....\n");
        }
        printf("I guess I am done... \n");
    }

    if (signo == SIGINT) {
        printf("Got SIGINT!\n");
        done = true;
    }
}

int main() {
    struct sigaction sa;

    sa.sa_handler = handler;
    sa.sa_flags = SA_RESTART;  // No special flags necessary.
    sigemptyset(&sa.sa_mask);  // Do not block additional signals during handler execution
    //we need this so that the trash in sa, isn't used to set the signal mask...we will talk about this soon...
    
    if (sigaction(SIGALRM, &sa, NULL) == -1) {  
        perror("Can't handle SIGALRM");
        exit(EXIT_FAILURE);
    }

    if (sigaction(SIGINT, &sa, NULL) == -1) {
        perror("Can't handle SIGINT");
        exit(EXIT_FAILURE);
    }

    alarm(1);

    while (!done) { }

    return EXIT_SUCCESS;
}
